/*  function */

#include <stdio.h>
#include <ctype.h>
#include "defines.h"

#define SYM  0    /* ⡼ */
#define VAR  1    /* ѿ̾⡼ */
#define NUM  2    /* ⡼ */

int getword(w)    /* ϥ롼 */
WORD *w;   /* ֤ͤᡢݥ󥿤Ϥ */
{	
	int	ic;        /* ʸ */
	int     count;     /* ʸХåեؤɲð֤򼨤ѿ */
	char	buff[256]; /* ʸХåե */
	int	flag;      /* ߤɤ߹ߤξ */

	flag = SYM;        /* flagν */
	while (1) {
		ic = toupper(getchar()); /* ʸɤ߹ */
		switch (ic) {
			case '+':
			case '-':
			case '*':
			case '/':
			case '=':
			case '(':
			case ')':
			case '\n':
			case EOF:   /* ξ */
			    switch (flag) {
				case SYM:
				    w->type = SYMBOL;
				    w->symbol = ic;
				    return;
				case NUM:
				    ungetc(ic,stdin);
				    buff[count] = '\0';
				    w->type = CONST;
				    w->value = atoi(buff);
				    return;
				case VAR:
				    ungetc(ic,stdin);
				    buff[count] = '\0';
				    w->type = VARNAME;
				    var_add(buff);
				    strcpy (w->var_name,buff);
				    return;
			    }
			    break;
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':   /* ե٥åȤξ */
			    switch (flag) {
				case SYM:
				    flag = VAR;
				    count = 0;
				    buff[count++] = ic;
				    break;
				case VAR:
				    buff[count++] = ic;
				    break;
				case NUM:
				    ungetc(ic,stdin);
				    buff[count] = '\0';
				    w->type = CONST;
				    w->value = atoi(buff);
				    return;
				}
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':    /* ξ */
			    switch (flag) {
				case SYM:
				    flag = NUM;
				    count = 0;
				    buff[count++] = ic;
				    break;
				case VAR:
				case NUM:
				    buff[count++] = ic;
				    break;
				}
				break;
			case ' ':
			case '\t':   /* ξ */
			    switch (flag) {
				case SYM:
				    /* skip blank & tab */
				    break;
				case VAR:
				    buff[count] = '\0';
				    w->type = VARNAME;
				    var_add(buff);
				    strcpy (w->var_name,buff);
				    return;
				case NUM:
				    buff[count] = '\0';
				    w->type = CONST;
				    w->value = atoi(buff);
				    return;
			    }
			    break;
			default:    /* ¾ʸ->顼 */
			    w->type = ERROR;
			    w->symbol = ic;
			    return;
		}
	}
}
