#include <stdio.h>
#include "defines.h"

code_gen()
{
	REVP *rp;
	WORD w;
	char store_var[256];

#ifdef DEBUG
	printf("generated code is :\n");
#endif
	rp = revp_top;
	if (rp->type != VARNAME) {
	    error("assignment target is not variable");
	    return;
	} else {
	    strcpy(store_var,rp->var_name);
	    rp = rp->next;
	}
	
	while (rp != NULL) {
	    switch (rp->type) {
		case SYMBOL:
		    switch (rp->symbol) {
		    	case '+':
		    	    printf("\tADD\n");
		    	    break;
		    	case '-':
		    	    printf("\tSUB\n");
		    	    break;
		    	case '*':
		    	    printf("\tMUL\n");
		    	    break;
		    	case '/':
		    	    printf("\tDIV\n");
		    	    break;
		    	case '=':
		    	    printf("\tPOP\tVar_%s\n",store_var);
		    	    return;
		    	    break;
		    }
		    break;
		case VARNAME:
		    printf("\tPUSH\tVar_%s\n",rp->var_name);
		    break;
		case CONST:
		    printf("\tPUSHI\t%d\n",rp->value);
	    	    break;
	    }
	    rp = rp->next;
	}
	error("abnomal end of expression");
}
