/* arcitecture simulator ver.1.0 [92/Aug/26-] */
/* header file for display procedures */

#include "global.h"

#define	COMMANDLINE	0	/* top line of command input area */
#define	ERRORLINE	3	/* top line of error message display area */
#define	CYCLELINE	4	/* top line of cycle display area */
#define INSTLINE	6	/* top line of instruction display area */
#define MEMLINE		8	/* top line of memory display area */
#define REGLINE		20	/* top line of register display area */

global	int	instdisp init(TRUE);	/* disassmbled inst. display flag */

global	int	memdisp init(TRUE);	/* MEM area display flag */

global	int	regdisp init(TRUE);	/* reg. area display flag */

global	int	regdisptop init(0);	/* reg. display start No. */

global	int	memdisptop init(0);	/* memory display start address */

global	int	waittime init(100000); /* wait time(microsec) after refresh */

extern	void	clearline();	/* clear specified line */
extern	void	dispinst();	/* display disassmbled instruction */
extern	void	dispreg();	/* display registers */
extern	void	dispmem();	/* display memories */
