/* architecture simulator ver.1.0 [92/Aug/26-] */
/* define global variables & macros      */

#include "global.h"

/* global  variables */

/* register */
#ifndef STACK_ARCH
global word regfile[REGSIZE];
#else
global stack *stacktop init(NULL); /* stack arch.'s stack top */
#endif

/* main memory */
global word memory[MEMSIZE];

/* special registers */
global word programcounter init(0);	/* prog. counter */
#define PC	programcounter

#ifdef ACCUM_ARCH
#define	ACC	regfile[0]	/* accumlator */
#endif

/* halt flag */
global int haltflag init(FALSE);	/* halt flag */

/* error flag */
global int errorflag init(FALSE);	/* halt flag */
