/* architecture simulator ver.1.0 [92/Aug./26-] */
/* dump memory procedure */

#include <stdio.h>

#include "defines.h"
#include "cmnvar.h"
#include "opcode.h"

int dumpmem(dumpfile,start,end)
char	*dumpfile;	/* dump filename */
int	start,end;	/* start&end address */
{
	int	i;
	FILE	*fp;
	
	if (start>end) return FALSE;

	if ((fp = fopen(dumpfile,"w")) == NULL) {
	    return (FALSE);
	}

	for (i = start ; i <= end ; i+=4) {
		fprintf(fp,"%04X: ",i & 0xffff);
		fprintf(fp,"%10d ",memory[i]);
		fprintf(fp,"%10d ",memory[i+1]);
		fprintf(fp,"%10d ",memory[i+2]);
		fprintf(fp,"%10d ",memory[i+3]);
		fprintf(fp,"\n");
	}
	fclose(fp);
	return (TRUE);
}
