/* architecture simulator ver.1.0 [92/Aug./26-] */
/* main procedure */

#define MAINPROGRAM

#include <stdio.h>
#include <signal.h>

#include "defines.h"
#include "cmnvar.h"
#include "opcode.h"
#include "display.h"
#include "debugger.h"

main(argc,argv)
int	argc;
char	*argv[];
{
	if (argc == 2) {
		strcpy(objfile,argv[1]);
	} else {
		usage(argv[0]);
		exit(1);
	}

	dispinit();

	signal(SIGINT,interrupt);

	debugger_main();

	dispfinish();

	signal(SIGINT,SIG_DFL);

	exit(0);
}

usage(progname)	/* usage print out */
char	*progname;
{
	fprintf(stderr,"usage:	%s objectfilename\n",progname);
}
